/*
 * Linux mainline API clocks implementation for MSM8998
 * Copyright (C) 2018, AngeloGioacchino Del Regno <kholk11@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 and
 * only version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

/* HWs */
#define GCC_XO					0
#define GCC_BI_TCXO				1
#define GCC_CE1_AHB_M_CLK			2
#define GCC_CE1_AXI_M_CLK			3
#define GCC_GPLL0_EARLY_DIV			4

/* PLLs */
#define GPLL0					0
#define GPLL0_AO				1
#define GPLL0_OUT_MAIN				2
#define GPLL1					3
#define GPLL1_OUT_MAIN				4
#define GPLL2					5
#define GPLL2_OUT_MAIN				6
#define GPLL3					7
#define GPLL3_OUT_MAIN				8
#define GPLL4					9
#define GPLL4_OUT_MAIN				10

/* GCC Clocks */
#define USB30_MASTER_CLK_SRC			20
#define PCIE_AUX_CLK_SRC			21
#define UFS_AXI_CLK_SRC				22
#define BLSP1_QUP1_I2C_APPS_CLK_SRC		23
#define BLSP1_QUP1_SPI_APPS_CLK_SRC		24
#define BLSP1_QUP2_I2C_APPS_CLK_SRC		25
#define BLSP1_QUP2_SPI_APPS_CLK_SRC		26
#define BLSP1_QUP3_I2C_APPS_CLK_SRC		27
#define BLSP1_QUP3_SPI_APPS_CLK_SRC		28
#define BLSP1_QUP4_I2C_APPS_CLK_SRC		29
#define BLSP1_QUP4_SPI_APPS_CLK_SRC		30
#define BLSP1_QUP5_I2C_APPS_CLK_SRC		31
#define BLSP1_QUP5_SPI_APPS_CLK_SRC		32
#define BLSP1_QUP6_I2C_APPS_CLK_SRC		33
#define BLSP1_QUP6_SPI_APPS_CLK_SRC		34
#define BLSP1_UART1_APPS_CLK_SRC		35
#define BLSP1_UART2_APPS_CLK_SRC		36
#define BLSP1_UART3_APPS_CLK_SRC		37
#define BLSP2_QUP1_I2C_APPS_CLK_SRC		38
#define BLSP2_QUP1_SPI_APPS_CLK_SRC		39
#define BLSP2_QUP2_I2C_APPS_CLK_SRC		40
#define BLSP2_QUP2_SPI_APPS_CLK_SRC		41	
#define BLSP2_QUP3_I2C_APPS_CLK_SRC		42
#define BLSP2_QUP3_SPI_APPS_CLK_SRC		43
#define BLSP2_QUP4_I2C_APPS_CLK_SRC		44
#define BLSP2_QUP4_SPI_APPS_CLK_SRC		45
#define BLSP2_QUP5_I2C_APPS_CLK_SRC		46
#define BLSP2_QUP5_SPI_APPS_CLK_SRC		47
#define BLSP2_QUP6_I2C_APPS_CLK_SRC		48
#define BLSP2_QUP6_SPI_APPS_CLK_SRC		49
#define BLSP2_UART1_APPS_CLK_SRC		50
#define BLSP2_UART2_APPS_CLK_SRC		51
#define BLSP2_UART3_APPS_CLK_SRC		52
#define GP1_CLK_SRC				53
#define GP2_CLK_SRC				54
#define GP3_CLK_SRC				55
#define HMSS_RBCPR_CLK_SRC			56
#define PDM2_CLK_SRC				57
#define SDCC2_APPS_CLK_SRC			58
#define SDCC4_APPS_CLK_SRC			59
#define TSIF_REF_CLK_SRC			60
#define UFS_ICE_CORE_CLK_SRC			61
#define UFS_PHY_AUX_CLK_SRC			62
#define UFS_UNIPRO_CORE_CLK_SRC			63
#define USB30_MOCK_UTMI_CLK_SRC			64
#define USB3_PHY_AUX_CLK_SRC			65
#define HMSS_GPLL0_CLK_SRC			66
#define QSPI_REF_CLK_SRC			67
#define GCC_USB3_PHY_RESET			68
#define GCC_USB3PHY_PHY_RESET			69
#define GCC_QUSB2PHY_PRIM_RESET			70
#define GCC_QUSB2PHY_SEC_RESET			71
#define GPLL0_OUT_MSSCC				72
#define GCC_AGGRE1_UFS_AXI_CLK			73
#define GCC_AGGRE1_UFS_AXI_HW_CTL_CLK		74
#define GCC_AGGRE1_USB3_AXI_CLK			75
#define GCC_BIMC_MSS_Q6_AXI_CLK			76
#define GCC_BLSP1_AHB_CLK			77
#define GCC_BLSP1_QUP1_I2C_APPS_CLK		78
#define GCC_BLSP1_QUP1_SPI_APPS_CLK		79
#define GCC_BLSP1_QUP2_I2C_APPS_CLK		80
#define GCC_BLSP1_QUP2_SPI_APPS_CLK		81
#define GCC_BLSP1_QUP3_I2C_APPS_CLK		82
#define GCC_BLSP1_QUP3_SPI_APPS_CLK		83
#define GCC_BLSP1_QUP4_I2C_APPS_CLK		84
#define GCC_BLSP1_QUP4_SPI_APPS_CLK		85
#define GCC_BLSP1_QUP5_I2C_APPS_CLK		86
#define GCC_BLSP1_QUP5_SPI_APPS_CLK		87
#define GCC_BLSP1_QUP6_I2C_APPS_CLK		88
#define GCC_BLSP1_QUP6_SPI_APPS_CLK		89
#define GCC_BLSP1_UART1_APPS_CLK		90
#define GCC_BLSP1_UART2_APPS_CLK		91
#define GCC_BLSP1_UART3_APPS_CLK		92
#define GCC_BLSP2_AHB_CLK			93
#define GCC_BLSP2_QUP1_I2C_APPS_CLK		94
#define GCC_BLSP2_QUP1_SPI_APPS_CLK		95
#define GCC_BLSP2_QUP2_I2C_APPS_CLK		96
#define GCC_BLSP2_QUP2_SPI_APPS_CLK		97
#define GCC_BLSP2_QUP3_I2C_APPS_CLK		98
#define GCC_BLSP2_QUP3_SPI_APPS_CLK		99
#define GCC_BLSP2_QUP4_I2C_APPS_CLK		100
#define GCC_BLSP2_QUP4_SPI_APPS_CLK		101
#define GCC_BLSP2_QUP5_I2C_APPS_CLK		102
#define GCC_BLSP2_QUP5_SPI_APPS_CLK		103
#define GCC_BLSP2_QUP6_I2C_APPS_CLK		104
#define GCC_BLSP2_QUP6_SPI_APPS_CLK		105
#define GCC_BLSP2_UART1_APPS_CLK		106
#define GCC_BLSP2_UART2_APPS_CLK		107
#define GCC_BLSP2_UART3_APPS_CLK		108
#define GCC_CFG_NOC_USB3_AXI_CLK		109
#define GCC_BIMC_GFX_CLK			110
#define GCC_GP1_CLK				111
#define GCC_GP2_CLK				112
#define GCC_GP3_CLK				113
#define GCC_GPU_BIMC_GFX_CLK			114
#define GCC_GPU_CFG_AHB_CLK			115
#define GCC_GPU_IREF_CLK			116
#define GCC_HMSS_DVM_BUS_CLK			117
#define GCC_HMSS_RBCPR_CLK			118
#define GCC_MMSS_NOC_CFG_AHB_CLK		119
#define GCC_MMSS_SYS_NOC_AXI_CLK		120
#define GCC_PCIE_0_AUX_CLK			121
#define GCC_PCIE_0_CFG_AHB_CLK			122
#define GCC_PCIE_0_MSTR_AXI_CLK			123
#define GCC_PCIE_0_PIPE_CLK			124
#define GCC_PCIE_0_SLV_AXI_CLK			125
#define GCC_PCIE_PHY_AUX_CLK			126
#define GCC_PCIE_PHY_RESET			127
#define GCC_PCIE_PHY_COM_RESET			128
#define GCC_PCIE_PHY_NOCSR_COM_PHY_RESET	129
#define GCC_PDM2_CLK				130
#define GCC_PDM_AHB_CLK				131
#define GCC_SDCC2_AHB_CLK			132
#define GCC_SDCC2_APPS_CLK			133
#define GCC_SDCC4_AHB_CLK			134
#define GCC_SDCC4_APPS_CLK			135
#define GCC_TSIF_AHB_CLK			136
#define GCC_TSIF_REF_CLK			137
#define GCC_UFS_AHB_CLK				138
#define GCC_UFS_AXI_CLK				139
#define GCC_UFS_AXI_HW_CTL_CLK			140
#define GCC_UFS_ICE_CORE_CLK			141
#define GCC_UFS_ICE_CORE_HW_CTL_CLK		142
#define GCC_UFS_PHY_AUX_CLK			143
#define GCC_UFS_PHY_AUX_HW_CTL_CLK		144
#define GCC_UFS_RX_SYMBOL_0_CLK			145
#define GCC_UFS_RX_SYMBOL_1_CLK			146
#define GCC_UFS_TX_SYMBOL_0_CLK			147
#define GCC_UFS_UNIPRO_CORE_CLK			148
#define GCC_UFS_UNIPRO_CORE_HW_CTL_CLK		149
#define GCC_USB30_MASTER_CLK			150
#define GCC_USB30_MOCK_UTMI_CLK			151
#define GCC_USB30_SLEEP_CLK			152
#define GCC_USB3_PHY_AUX_CLK			153
#define GCC_USB3_PHY_PIPE_CLK			154
#define GCC_PRNG_AHB_CLK			155
#define GCC_BOOT_ROM_AHB_CLK			156
#define GCC_MSS_CFG_AHB_CLK			157
#define GCC_MSS_Q6_BIMC_AXI_CLK			158
#define GCC_MSS_MNOC_BIMC_AXI_CLK		159
#define GCC_MSS_SNOC_AXI_CLK			160
#define GCC_HDMI_CLKREF_CLK			161
#define GCC_PCIE_CLKREF_CLK			162
#define GCC_RX1_USB2_CLKREF_CLK			163
#define GCC_UFS_CLKREF_CLK			164
#define GCC_USB3_CLKREF_CLK			165
#define GCC_DCC_AHB_CLK				166
#define HLOS1_VOTE_LPASS_CORE_SMMU_CLK		167
#define HLOS1_VOTE_LPASS_ADSP_SMMU_CLK		168
#define GCC_QSPI_AHB_CLK			169
#define GCC_QSPI_REF_CLK			170
#define GCC_GPU_GPLL0_CLK			171
#define GCC_GPU_GPLL0_DIV_CLK			172
#define GCC_MMSS_GPLL0_CLK			173
#define GCC_MMSS_GPLL0_DIV_CLK			174
#define GCC_USB_PHY_CFG_AHB2PHY_CLK		175

/* GCC block resets */
#define QUSB2PHY_PRIM_BCR			0
#define QUSB2PHY_SEC_BCR			1
#define BLSP1_BCR				2
#define BLSP2_BCR				3
#define BOOT_ROM_BCR				4
#define PRNG_BCR				5
#define UFS_BCR					6
#define USB_30_BCR				7
#define USB3_PHY_BCR				8
#define USB3PHY_PHY_BCR				9
#define PCIE_0_PHY_BCR				10
#define PCIE_PHY_BCR				11
#define PCIE_PHY_COM_BCR			12
#define PCIE_PHY_NOCSR_COM_PHY_BCR		13
